/* matrixtastatur.c

Beispielcode um Matrixtastatur abzufragen

 */

//#define ATMEGA2560  //auskommentiert weil schon im makefile definiert
//#define MATRIXIN_SHIFT2

#ifdef ATMEGA644
#define F_CPU 20000000
#else
#define F_CPU 16000000
#endif

#include <avr/io.h>
#include "lcd_treiber.c"

#define PORT_MATRIXOUT PORTE //Mit Spalten verbundener Port
#define DDR_MATRIXOUT  DDRE

#define PORT_MATRIXIN  PORTF //Mit Reihen verbundener Port
#define PIN_MATRIXIN   PINF
#define DDR_MATRIXIN   DDRF
#define NREIHEN 6
#define NSPALTEN 5

void init_matrix()
{
 PORT_MATRIXOUT=0xFF; //Pullup-Widerstaende setzen
#ifdef MATRIXIN_SHIFT2
 PORT_MATRIXIN=0xFC;  //Pullup-Widerstaende setzen, ohne 2 unterste Bits
#else
 PORT_MATRIXIN=0xFF;  //Pullup-Widerstaende setzen
#endif
 DDR_MATRIXOUT=0; //Ausgabe-Leitungen vorlaeufig auf Eingang setzen
 DDR_MATRIXIN=0;  //Eingabe-Leitungen auf Eingang setzen
}

uint8_t matrix_einlesen()
{
 uint8_t spalte,reihe,nr=0,reihe_mal_n;
 for(spalte=0; spalte<NSPALTEN; spalte++)
  {
   DDR_MATRIXOUT = (1<<spalte);   //nur aktuelle Spalte DDR auf Ausgang
   PORT_MATRIXOUT = ~(1<<spalte); //nur aktuelle Spalte PORT auf 0 setzen
   MILLIWAIT(1);
   for(reihe=0,reihe_mal_n=0; reihe<NREIHEN; reihe++,reihe_mal_n+=NSPALTEN)
    {
#ifdef MATRIXIN_SHIFT2
     if((PIN_MATRIXIN&(1<<(reihe+2)))==0)
#else
     if((PIN_MATRIXIN&(1<<reihe))==0)
#endif
       {nr=reihe_mal_n+spalte+1;}
    }
  }
 DDR_MATRIXOUT = 0;
 PORT_MATRIXOUT = 0xFF;
 return nr;
}

uint8_t check_matrix()
{
 uint8_t nr;
 nr=matrix_einlesen();
 if(nr==matrix_einlesen()) //gleicher Wert bei erneutem Einlesen?
  return nr; //ja: entprellte Taste
 return 0; //nein: noch nicht entprellt
}

int main (void)
{
 uint8_t x=0;
 char text[40];
 glcd_init();				// init des LCD
 glcd_clear();				// LCD loeschen
 glcd_licht(true);			// beleuchtung einschalten
 init_matrix();

 while (true)
  {
   x=check_matrix();
   if(x!=0)
    {
     sprintf(text,"Taste %d gedrueckt.   ",x);
     glcd_moveto(0,16);
     glcd_print(text);
     //matrixtasten[2]=1;//test
     while(check_matrix()!=0) ;//warte bis Taste wieder losgelassen
    }
   else
    {
     glcd_moveto(0,16);
     glcd_print("keine Taste gedrueckt");
     //matrixtasten[2]=0;//test
    }
   MILLIWAIT(500); //0.5 Sek lang warten
  }
 return 0;
}
